SystemOrganization addCategory: #ConfigurationOfMass!

Object subclass: #ConfigurationOfMass
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfMass'!

!ConfigurationOfMass class methodsFor: 'development support' stamp: 'NickPapoulias 1/1/2016 17:49'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfMass class methodsFor: 'private' stamp: 'NickPapoulias 1/1/2016 17:49'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfMass class methodsFor: 'private' stamp: 'NickPapoulias 1/1/2016 17:49'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfMass class methodsFor: 'private' stamp: 'NickPapoulias 1/1/2016 17:49'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfMass class methodsFor: 'metacello tool support' stamp: 'NickPapoulias 1/1/2016 17:49'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfMass class methodsFor: 'loading' stamp: 'NickPapoulias 1/1/2016 17:49'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfMass class methodsFor: 'loading' stamp: 'NickPapoulias 1/1/2016 17:49'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfMass class methodsFor: 'loading' stamp: 'NickPapoulias 1/1/2016 17:49'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfMass class methodsFor: 'accessing' stamp: 'NickPapoulias 1/1/2016 17:49'!
project

	^self new project! !

!ConfigurationOfMass class methodsFor: 'development support' stamp: 'NickPapoulias 1/1/2016 17:49'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfMass methodsFor: 'accessing' stamp: 'NickPapoulias 1/1/2016 18:05'!
baselineDev: spec

	<version: 'dev-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://ss3.gemtalksystems.com/ss/Mass' "username: '' password: ''".
		spec project: 'JQueryMobile' with: [
			spec 
				className: 'ConfigurationOfJQueryMobile';
				repository: 'http://ss3.gemstone.com/ss/jQueryMobile'.
		].
		spec package: 'Mass'.
	 ]
! !

!ConfigurationOfMass methodsFor: 'accessing' stamp: 'NickPapoulias 1/1/2016 17:49'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfMass methodsFor: 'accessing' stamp: 'NickPapoulias 1/1/2016 20:23'!
versionDev: spec

	<version: 'dev' imports: #('dev-baseline')>
	
	spec for: #common do: [
		spec project: 'JQueryMobile' with: #bleedingEdge.
		spec package: 'Mass' with: 'Mass-NickPapoulias.3'.
	 ]
! !
